* DOS LOGO Double densit pour TO
* Enregistr sur la disquette  partir de la piste 0, secteur 1
* Reverse-engineering par Fool-DupleX, 12.2022

        ORG     $7C80
        
DOSLOG  EQU     *        
        
        FCB     $06                   Nb secteurs a charger
        FCB     $10                   Nb secteurs par piste
        
SECSIZ  EQU     *
        FDB     $0100                 Taille d'un secteur sur 16 bits
        
        FDB     $6048                 Magic secteur de boot TO
        FDB     $6048                 (Deux fois)
        
        FDB     INIT                  Point d'entree initialisations
        FDB     START                 Point d'entree principal
        
        FCC     /8 OCTETS/            Filler

*******************************************************************************
        
INIT    EQU     *                     Ne fais rien.
        RTS
        
        FCC     /D.O.S. =/       
        FCB     $0D,$04

*******************************************************************************
        
START   EQU     *
        LDX     #PRIMTBL              Table des nouvelles primitives            
        LDD     [$0047]               Fin de la mmoire utilisateur
        SUBD    #$0002             
        PSHS    B,A                
        LDD     #FINDOS               Fin du code du DOS             
        PSHS    B,A                  
        JSR     [$0024]               Routine d'installation ($343A)
        LDA     SECSIZ              
        STA     $6319              
        PULS    X                     Recupere adresse source (sup.)
        PULS    Y                     Recupere adresse d'implantation (sup.)     

MEMCPY  EQU     *                     Recopie le code
        LDD     ,--X                 
        STD     ,--Y               
        CMPX    #PRIMFIN              Fin de la table des nouvelles primitives             
        BEQ     EPILOG              
        BHI     MEMCPY              
        LEAY    $01,Y                 Remonte le ptr si longueur impaire

EPILOG  EQU     *              
        STY     [$0047]               Fin de la memoire utilisateur
        CLR     $60EF                 Lecteur courant = 0:
        LEAY    $05,Y              
        STY     [$0036]               Point d'entree peripherique disque
        CLR     $60EF                 Lecteur courant = 0:
        RTS

*******************************************************************************
        
PRIMTBL EQU     *
        FCC     /.DS/                 Nom de la primitive : .DSK
        FCB     'K+$80
        FDB     DSK                   Point d'entree
        FCB     $05                   Nombre de parametres

        FCC     /CATALOGU/            Nom de la primitive : CATALOGUE
        FCB     'E+$80  
        FDB     CATALG                
        FCB     $00                   
                
        FCC     /FORMAT/              Nom de la primitive : FORMATE
        FCB     'E+$80
        FDB     FORMAT
        FCB     $01
                
        FCC     /DETRUI/              Nom de la primitive : DETRUIS
        FCB     'S+$80
        FDB     DETRUIS
        FCB     $01
                      
PRIMFIN EQU     *-1        

        FDB     $0000                 Flag de fin de table = $0000
        FDB     $0000                 Rserv pointeur de liste

*******************************************************************************        

PE_DSK  EQU     *        
        LBRA    DISK                  Point d'entree peripherique disque             

*******************************************************************************

PROCESS EQU     *
        PSHS    U,Y,X,DP,B,A       
        LDA     #$60               
        TFR     A,DP               
        LDB     <$EF                  Lecteur courant
        STB     <$49                  DKDRV
        LDX     <$E9                  Ptr buffer secteur
        STX     <$4F                  DKBUF
        LDA     #$01               
        LDB     <$E6                  Operation a realiser
        LBEQ    OPER0                 = 0

        CMPB    #$02                  = 2
        LBEQ    OPER2              

        CMPB    #$01                  = 1    
        BEQ     OPER1              

        CMPB    #$03                  = 3
        LBEQ    OPER3              

        CMPB    #$04                  = 4, Catalogue
        LBEQ    OPER4              

        CMPB    #$05                  = 5, Formate
        LBEQ    OPER5              

        CMPB    #$06                  = 6, Detruis
        LBEQ    OPER6              
     
ERR1    EQU     *        
        STA     <$E5                  Operation inconnue, erreur = 1
        
ERR0    EQU     *                       
        COMA                      
        
SUCCES  EQU     *+1                   (CLR <$E5 - pas d'erreur)
        TST     $0FE5                        
                      
        PULS    A,B,DP,X,Y,U,PC  

*******************************************************************************

OPER1   EQU     *
        TST     <$F0               
        BNE     LBL1
                      
        LBSR    ROUT1
        
LBL9    EQU     *                      
        BCS     ERR0              
        
        LDA     #$04               
        TSTB                      
        BEQ     ERR1              
        
        BRA     LBL2              

LBL1    EQU     *        
        LDX     <$F3                  Ptr courant
        CMPX    <$F1                  Ptr sur la fin
        BNE     LBL3              
        
        LDA     <$F9                  Dernier secteur+1 du bloc courant
        CMPA    <$F5                  Compteur de secteurs
        BEQ     LBL4              
        
        BHI     LBL5              

        CLR     <$E6                  Operation a realiser
        
SUCC0   EQU     *                       
        CLR     <$F0                  Code op en cours

SUCC0A  EQU     *
        BRA     SUCCES              
    
LBL4    EQU     *        
        CMPA    #$09               
        BNE     LBL5              

LBL2    EQU     *        
        LDY     <$ED                  Ptr FAT
        JSR     $E01F                 Init. operation sur bloc          
        LDB     <$F6                  No. bloc courant
        INCB                      
        LDA     B,Y                
        STA     <$F6                  No. bloc courant
        LDB     #$09               
        STB     <$F9                  Dernier secteur +1 bloc courant
        CMPA    #$C0               
        BCS     LBL5
                      
        ANDA    #$0F               
        STA     <$F9

LBL5    EQU     *               
        LDX     <$E9                  Ptr buffer secteur
        STX     <$F3                  Ptr courant
        LDB     #$80               
        TST     $6319              
        BEQ     LBL6
                      
        ADDB    #$7F
               
LBL6    EQU     *               
        LDA     <$F5                  Compteur de secteurs
        CMPA    <$F9               
        BCS     LBL7
                      
        LDD     <$F7
        
LBL7    EQU     *                       
        CLRA                      
        LEAX    D,X                
        STX     <$F1               
        LDA     <$FA               
        INC     <$FA               
        INC     <$F5               
        STA     <$4C               
        LDD     <$FB               
        STD     <$4A               
        JSR     $E004                 DKCOH      
        LDA     #$03
        
ERR2    EQU     *                       
        BCS     ERR1
                      
        LDX     <$F3
               
LBL3    EQU     *               
        LDB     ,X+                
        STX     <$F3               
        STB     $01,S              
        BRA     SUCC0A

*******************************************************************************

OPER3   EQU     *
        TST     <$F0               
        BNE     LBL8
                      
        BSR     ROUT1
        
LBL11   EQU     *                      
        BCS     LBL9
                      
        TSTB                      
        BEQ     LBL10              
        JSR     $E013                 Effacement d'un fichier
        
ERR3    EQU     *        
        BCS     ERR2
                      
        BRA     LBL10

*******************************************************************************

ROUT1   EQU     *                     Ouverture d'un fichier
        STB     <$F0               

ROUT1A  EQU     *
        JSR     $E00D                 Chargement de la FAT              
        BCS     FIN0
                      
        JSR     $E010                 Ouverture d'un fichier
        
FIN0    EQU     *                      
        RTS                       

*******************************************************************************

OPER2   EQU     *
        TST     <$F0               
        BNE     LBL8              
        
        BSR     ROUT1              
        BCS     LBL11
                      
        LDA     #$08               
        TSTB    
        
ERR4    EQU     *                          
        LBNE    ERR1              

LBL10   EQU     *
        JSR     $E019                 Creation d'un fichier

LBL10A  EQU     *                      
        BCS     LBL11
        LDX     <$E9               
        STX     <$F3               
        LEAX    $0080,X            
        TST     $6319              
        BEQ     LBL12
                      
        LEAX    $7F,X
         
LBL12   EQU     *                     
        STX     <$F1               
        JSR     $E01F                 Init. operation sur bloc             

LBL8    EQU     *
        LDX     <$F3               
        CMPX    <$F1               
        BCS     LBL13
                      
        BSR     ROUT2

ERR5    EQU     *                      
        BCS     ERR3
                      
        LDX     <$E9               
        STX     <$F3               
        LDA     <$FA               
        INC     <$FA               
        INC     <$F5               
        CMPA    #$08               
        BEQ     LBL14
                      
        CMPA    #$10               
        BNE     LBL13
        
LBL14   EQU     *                      
        LDY     <$ED               
        JSR     $E01C                 Allocation d'un bloc
        
ERR6    EQU     *        
        BCS     LBL10A
                      
        LDA     <$F6               
        STB     <$F6               
        INCA                      
        STB     A,Y                
        JSR     $E01F                 Init. operation sur bloc
        
LBL13   EQU     *                      
        LDB     $01,S              
        LDX     <$F3               
        STB     ,X+                
        STX     <$F3
          
SUCC1   EQU     *                     
        LBRA    SUCCES

*******************************************************************************

ROUT2   EQU     *                     Ecriture d'un secteur
        LDA     <$FA               
        STA     <$4C               
        LDD     <$FB               
        STD     <$4A               
        JMP     $E016                 Ecriture d'un secteur

*******************************************************************************

OPER0   EQU     *
        LDA     #$01               
        LDB     <$F0               
        BITB    #$02               
        LBEQ    ERR1
                      
        BSR     ROUT2              
        BCS     ERR5
                      
        LDY     <$ED               
        LDA     <$F6               
        LDB     <$F5               
        EORB    #$C0               
        INCA                      
        STB     A,Y                
        JSR     $E010                 Ouverture d'un fichier
        BCS     ERR6
                      
        LDD     <$F3               
        SUBD    <$E9               
        STD     $0E,Y              
        JSR     $E016                 Ecriture d'un secteur              
        BCS     ERR5
                      
        JSR     $E022                 Cloture d'ecriture              
        BCS     ERR5
                      
        BRA     SUCC1              

*******************************************************************************

OPER4   EQU     *                     Catalogue
        LDX     <$ED               
        STX     <$4F               
        LDA     #$03               
        JSR     $E00D                 Chargement de la FAT

ERR7    EQU     *        
        BCS     ERR5              

        LDD     #$1402                Piste 20, secteur 2
        STA     <$4B               
        STB     <$48               
        LDB     #$03
        
LBL21   EQU     *                       
        STB     <$4C               
        LDX     <$E9               
        STX     <$4F               
        PSHS    X                  
        LEAX    $0080,X            
        TST     $6319              
        BEQ     LBL15              

        LEAX    $0080,X 
        
LBL15   EQU     *                
        STX     <$F1               
        PULS    X                  
        JSR     $E004                 DKCOH              
        LDA     #$03               
        
ERR8    EQU     *        
        BCS     ERR7
                     
LBL20   EQU     *                      
        TFR     X,Y                
        LDA     ,X                 
        BEQ     LBL16
                      
        COMA                      
        LBEQ    SUCCES              

        LDA     #$08               
        LBSR    ROUT3              
        LDA     #$03               
        LBSR    ROUT3              
        LDA     ,X+                
        LDB     #$2A               
        CMPA    #$09               
        BHI     LBL17
                      
        LEAU    FTYPE,PCR          
        LDB     A,U

LBL17   EQU     *
        LBSR    ROUT5              
        LBSR    ROUT3A              
        LDB     #$42               
        ADDB    ,X+                
        LBSR    ROUT5              
        LBSR    ROUT3A              
        LDU     <$ED               
        LEAU    $01,U
        LDB     ,X+                
        CLRA
        
LBL19   EQU     *                              
        INCA                      
        BNE     LBL18
                     
        LDA     #$03               
        LBRA    ERR1

LBL18   EQU     *           
        LEAX    ,U
        ABX                 
        LDB     ,X                 
        CMPB    #$C0               
        BCS     LBL19
                      
        PSHS    A                  
        TFR     A,B                
        CLRA                      
        TST     $6319
        BEQ     LBL18A

        ASLB
        ROLA

LBL18A  EQU     *
        LDX     <$E9               
        LBSR    ROUT4              
        LBSR    ROUT6              
        PULS    A                  
        LDB     #$0D               
        LBSR    ROUT5

LBL16   EQU     *           
        TFR     Y,X                
        LEAX    $20,X              
        CMPX    <$F1               
        BCS     LBL20
                      
        LDB     <$4C               
        INCB                      
        CMPB    #$10               
        LBLS    LBL21
        
SUCC2   EQU     *                      
        LBRA    SUCCES              

*******************************************************************************

OPER5   EQU     *                     Formate
        LDA     #$04               
        STA     <$4D               
        LDA     #$03               
        JSR     $E00A                 Formatage
        
ERR9    EQU     *                      
        LBCS    ERR8
                     
SUCC3   EQU     *                      
        BRA     SUCC2              

*******************************************************************************

OPER6   EQU     *                     Detruis
        LBSR    ROUT1A              
        BCS     ERR9
                      
        LDA     #$04               
        TSTB                      
        LBEQ    ERR1
                      
        CLR     ,Y                 
        LDB     $0D,Y              
        LDY     <$ED 
        
LBL23   EQU     *                      
        INCB                      
        LDA     B,Y                
        CMPA    #$C0               
        BCC     LBL22
                      
        PSHS    A                  
        LDA     #$FF               
        STA     B,Y                
        PULS    B                  
        BRA     LBL23
        
LBL22   EQU     *                      
        LDA     #$FF               
        STA     B,Y                
        LDX     <$E7               
        CLR     ,X                 
        LDA     #$01               
        JSR     $E016                 Ecriture d'un secteur
        BCS     ERR9
                      
        JSR     $E022                 Cloture d'ecriture              
        BCS     ERR9
                      
        BRA     SUCC3

*******************************************************************************
                
FTYPE   EQU     *  
        FCC     /BDMA/                BASIC, Data, Machine, ASCII

*******************************************************************************

ROUT4   EQU     *                     Conversion decimale
        PSHS    U,X,B,A            
        LEAU    DCMALS,PCR
        
LBL25   EQU     *                  
        LDA     #$2F                  Caractere avant le 0
        STA     ,X                 
        LDD     ,S
        
LBL24   EQU     *                         
        INC     ,X                    Incremente caractere
        STD     ,S                 
        SUBD    ,U                 
        BCC     LBL24
                      
        LEAU    $02,U              
        LEAX    $01,X                 Chiffre suivant
        LDD     ,U                 
        BNE     LBL25
                      
        LDA     #$04                  Fin de chaine de caracteres
        STA     ,X                 
        PULS    A,B,X,U,PC         

DCMALS  EQU     *
        FDB     $0064,$000A           Centaines, dizaines, 
        FDB     $0001,$0000           unites, flag de fin (0000)

*******************************************************************************

ROUT3   EQU     *                     Affichage d'une chane de caracteres
        LDB     ,X+                
        BSR     ROUT5              
        DECA                      
        BNE     ROUT3

ROUT3A  EQU     *                     Affiche espace
        LDB     #$20               

ROUT5   EQU     *                     Affichage caractre
        PSHS    DP,A               
        LDA     #$62               
        TFR     A,DP               
        LDA     ,S                 
        JSR     [$002A]               Envoie sur le peripherique de sortie
        PULS    A,DP,PC            

*******************************************************************************

ROUT6   EQU     *                     
        PSHS    DP,A               
        LDA     #$62               
        TFR     A,DP               
        LDA     ,S                 
        JSR     [$0030]               
        PULS    A,DP,PC            

*******************************************************************************

ROUT7   EQU     *
        JSR     [$0026]            
        JMP     [$0028]                  

*******************************************************************************

DSK     EQU     *                     Primitive .DSK
        BSR     ROUT7
        STD     $604F                 Adresse tampon
        BSR     ROUT7
        STB     $604C                 No. secteur
        BSR     ROUT7
        STD     $604A                 No. piste               
        BSR     ROUT7
        STB     $6049                 No. lecteur
        BSR     ROUT7
        STB     $6048                 Mot de commande            
        LDU     #$6048             
        JSR     $E004              
        BCS     LBL27

        CLR     $604E              

LBL27   EQU     *
        JSR     [$003A]            
        LDB     $604E              
        STB     ,X                 
        LDA     #$08               
        STA     $04,X              
        TFR     X,Y                
        JMP     [$0040]            

*******************************************************************************

FORMAT  EQU     *
        JSR     [$0026]               Lit parametre
        JSR     [$0028]               Lit parametre
        LBNE    LBL26

        CMPD    #$0004                Disque doit etre entre 0 et 3
        LBCC    LBL26
                      
        LDA     $60EF                 Sauve le disque courant
        PSHS    A                  
        STB     $60EF                 Selectionne le disque a formater
        LDA     #$05                  Operation type 5
        STA     $60E6              
        LBSR    PROCESS
        PULS    A                  
        STA     $60EF                 Restaure le disque courant
        BCS     ERREUR

        RTS                       

*******************************************************************************

DETRUIS EQU     *
        JSR     [$002C]               Lit parametre
        LBNE    LBL26
                      
        JSR     [$002E]               

LBL30   EQU     *
        LDA     #$06                  Operation type 6
        STA     $60E6              
        LBSR    PROCESS             

        BCC     DETRET
 
        LDA     $60E5              
        CMPA    #$04               
        BNE     ERREUR

        COM     $60EC              
        BEQ     LBL30
        DEC     $60EC              

        BPL     LBL30

        BRA     ERREUR

DETRET  EQU     *
        RTS                       

*******************************************************************************

CATALG  EQU     *
        LDA     #$04                   Operation type 4
        BSR     ROUT8
        LDB     #$0D                   Retour a la ligne
        JMP     [$002A]            

*******************************************************************************

ROUT8   EQU     *
        STA     $60E6              

DISK    EQU     *
        PSHS    X                  
        LDX     <$38               
        STX     <$77               
        LDA     #$03               
        STA     $60E5              
        PULS    X                  
        LBSR    PROCESS
        BCC     DETRET
                      
ERREUR  EQU     *                       
        CLR     $60F0                 Code opration logique en cours              
        LDA     $60E5                 Numro d'erreur              
        CMPA    #$02                  = 2
        BEQ     ERRGEN              

        CMPA    #$03                  = 3
        BEQ     ERRGEN              

        CMPA    #$04                  = 4, fichier non trouv
        BEQ     ERR04              

        CMPA    #$05                  = 5, disque plein
        BEQ     ERR05              

        CMPA    #$08                  = 8, le fichier existe dj
        BEQ     ERR08

ERRGEN  EQU     *                         
        LEAX    NONPRET,PCR           Le disque n'est pas prt          
        BRA     AFFICH
                    
ERR04   EQU     *                    
        LEAX    NONTROU,PCR           Le fichier n'a pas t trouv          
        BRA     AFFICH

ERR05   EQU     *            
        LEAX    DKPLEIN,PCR           Le disque est plein
        BRA     AFFICH

ERR08   EQU     *           
        LEAX    EXTDEJA,PCR           Le fichier existe dj

AFFICH  EQU     *
        LDB     #$01               
        LBSR    $7FAE              
        JSR     [$0030]            

*******************************************************************************
 
LBL26   EQU     * 
        JMP     [$0034] 

*******************************************************************************
           
NONPRET EQU     *
        FCC     /DISQUE NON PRET/
        FCB     $0D,$04

NONTROU EQU     *
        FCC     /NON TROUVE/
        FCB     $0D,$04
        
DKPLEIN EQU     *
        FCC     /DISQUE PLEIN/
        FCB     $0D,$04
        
EXTDEJA EQU     *
        FCC     /EXISTE DEJA/
        FCB     $0D,$04                        

*******************************************************************************        

FINDOS EQU      *

       END
